apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ scalelite_name }}
  name: {{ scalelite_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ scalelite_replicas }}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ scalelite_name }}
  strategy:
    type: RollingUpdate
{% else %}
    name: {{ scalelite_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Rolling
{% endif %}
  template:
    metadata:
      labels:
        name: {{ scalelite_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ scalelite_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ scalelite_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: BEHIND_PROXY
          value: "true"
        - name: DATABASE_URL
          valueFrom:
            secretKeyRef:
              key: database-url
              name: {{ slpg_name }}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: HOME
          value: /srv/scalelite
        - name: LOADBALANCER_SECRET
          valueFrom:
            secretKeyRef:
              key: loadbalancer-key
              name: {{ scalelite_name }}
        - name: NGINX_SSL
          value: "false"
        - name: RECORDING_IMPORT_POLL
          value: "false"
        - name: REDIS_URL
          value: redis://{{ cache_name }}-proxy:6379
        - name: SECRET_KEY_BASE
          valueFrom:
            secretKeyRef:
              key: secret-key
              name: {{ scalelite_name }}
        - name: TZ
          value: {{ timezone }}
        - name: URL_HOST
          value: scalelite.{{ root_domain }}
{% if do_triggers == False or (opsimages | json_query("[?name=='scalelite_api'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='scalelite_api'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 29
{% else %}
          failureThreshold: 5
{% endif %}
          tcpSocket:
            port: 3000
        name: api
        ports:
        - containerPort: 3000
        resources:
          limits:
            cpu: "{{ scalelite_cpu_limit }}"
            memory: "{{ scalelite_memory_limit }}"
          requests:
            cpu: "{{ scalelite_cpu_request }}"
            memory: "{{ scalelite_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 29
          tcpSocket:
            port: 3000
{% endif %}
        volumeMounts:
        - mountPath: /srv/scalelite/tmp
          name: temp
          subPath: sctemp
        - mountPath: /usr/local/share/ca-certificates
          name: pkiconf
        - mountPath: /var/bigbluebutton
          name: recordings
      - env:
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: NGINX_HOST
          value: scalelite.{{ root_domain }}
        - name: NGINX_PORT
          value: "8080"
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='scalelite_nginx'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='scalelite_nginx'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        name: nginx
        ports:
        - containerPort: 8080
{% if do_exporters %}
        - containerPort: 9112
{% endif %}
        resources:
          limits:
            cpu: "{{ scalelite_nginx_cpu_limit }}"
            memory: "{{ scalelite_nginx_memory_limit }}"
          requests:
            cpu: "{{ scalelite_nginx_cpu_request }}"
            memory: "{{ scalelite_nginx_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /var/bigbluebutton/published
          name: recordings
          subPath: published
        - mountPath: /var/cache/nginx
          name: temp
          subPath: nxcache
        - mountPath: /var/run
          name: temp
          subPath: nxrun
{% if do_exporters %}
      - args:
        - --nginx.scrape-uri
        - http://stats:9112/basic_status
{% if do_triggers == False or (opsimages | json_query("[?name=='nginxexporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='nginxexporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          initialDelaySeconds: 30
          tcpSocket:
            port: 9113
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: {{ exporter_cpu_limit }}
            memory: {{ exporter_memory_limit }}
          requests:
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
      - env:
        - name: API_BASE_URL
          value: http://scalelite.{{ root_domain }}:8080/bigbluebutton/api/
        - name: API_SECRET
          valueFrom:
            secretKeyRef:
              key: loadbalancer-key
              name: {{ scalelite_name }}
        - name: BIND_IP
          value: 0.0.0.0
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: RECORDINGS_METRICS
          value: "true"
        - name: PORT
          value: "9114"
        - name: TLS_VERIFY
          value: "false"
{% if do_triggers == False or (opsimages | json_query("[?name=='scalelite_exporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='scalelite_exporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          initialDelaySeconds: 30
          tcpSocket:
            port: 9114
          timeoutSeconds: 3
        name: bbb-exporter
        ports:
        - containerPort: 9114
        resources:
          limits:
            cpu: {{ exporter_cpu_limit }}
            memory: {{ exporter_memory_limit }}
          requests:
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% endif %}
{% if do_exporters %}
      hostAliases:
      - ip: 127.0.0.1
        hostnames:
        - scalelite.{{ root_domain }}
        - stats
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
      securityContext:
        runAsUser: {{ k8s_unprivileged_userid }}
{% else %}
      securityContext: {}
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ scalelite_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
{% if (k8s_flavor != 'openshift' and tls_provider == 'internalca') or (bigbluebutton_ca_bundle | default([])) | length > 0 %}
      - name: pkiconf
        projected:
          sources:
{% if k8s_flavor != 'openshift' and tls_provider == 'internalca' %}
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% if (bigbluebutton_ca_bundle | default([])) | length > 0 %}
{% for cert in bigbluebutton_ca_bundle %}
          - configMap:
              items:
              - key: bigbluebutton-chain{{ loop.index0 }}.crt
                path: bigbluebutton-chain{{ loop.index0 }}.crt
              name: {{ scalelite_name }}
{% endfor %}
{% endif %}
{% else %}
      - emptyDir: {}
        name: pkiconf
{% endif %}
      - name: recordings
        persistentVolumeClaim:
          claimName: {{ scalelite_name }}
      - emptyDir: {}
        name: temp
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='scalelite_api'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - api
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='scalelite_api'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if (opsimages | json_query("[?name=='scalelite_nginx'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - nginx
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='scalelite_nginx'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_exporters %}
{% if (opsimages | json_query("[?name=='nginxexporter'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - exporter
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='nginxexporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if (opsimages | json_query("[?name=='scalelite_exporter'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - bbb-exporter
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='scalelite_exporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% endif %}
  - type: ConfigChange
{% endif %}
